
/*
* ATMEGA644V
* Quarz 11059200 MHZ
* printf("xxx") eingebunden
*/

#include "tools.h"

int uart_putchar(char c, FILE *stream);
void rv3029_schreiben(void);
void rv3029_lesen(void);
char rtc_bcd_to_hex(char v);
char rtc_hex_to_bcd(char v);
void ausgabe(void);

#define SLAVE_ADRESSE 0xAC



typedef struct { 			//  -------- Struktur ----------- fr globale Daten
	uint8_t control_0;		//C0 		0x00
	uint8_t control_1;		//C1
	uint8_t minute;			//min
	uint8_t stunde;			//std
	} MY_BUFFER;

	static MY_BUFFER rtc_buf; 

static FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE); // bindet printf() ein

int main(void)
{
	
	
	stdout = &mystdout; // bindet printf() ein 
	DDRC = 0x03; //SCL/SDA Out
	i2c_init();  
	sei();
	uart_init( UART_BAUD_SELECT(115200UL,11059200UL) );

	rv3029_schreiben();  // Uhr stellen, einmal ausfhren

while (1)
{
	

	rv3029_lesen();
	_delay_ms(250);
	_delay_ms(250);
	ausgabe();

}


		return (0);
}

void ausgabe(void) 	// RTC Uhr RV3209CS auslesen und auf Display ausgeben, 
				
	{
 
 	printf("Zeit:  %02d:%02d\r\n",rtc_buf.stunde,rtc_buf.minute);// Ausgabe Stunde, Minute
	
	}


void rv3029_schreiben(void)
{
   
    	i2c_start_wait(SLAVE_ADRESSE+I2C_WRITE);       // set device address and write mode
  		

		i2c_write(0x00);                       // Startadresse
		i2c_write(0xE9);                       // REG0
		i2c_write(0x00);                       // REG1
		i2c_stop();                            // Bus stop
	


  		i2c_start_wait(SLAVE_ADRESSE+I2C_WRITE);       // set device address and write mode
    		
	
		i2c_write(0x09); // Startadresse 
		i2c_write(0x38); // Minuten 	// aktuelle Zeit eingeben
		i2c_write(0x18); // Stunden  
		
		i2c_stop();      // Bus stop
	



}

//--------------------------------lesen--------------------------		
void rv3029_lesen(void)
{
 
	i2c_start_wait(SLAVE_ADRESSE+I2C_WRITE);       // set device address and write mode
 	i2c_write(0x09);  // Startadresse
	i2c_stop(); 
		                           // Bus stop
	
    i2c_rep_start(SLAVE_ADRESSE+I2C_READ);       // set device address and write mode
	
		
	rtc_buf.minute   = rtc_bcd_to_hex(i2c_readAck())& 0x7f; 	//min
	rtc_buf.stunde   = rtc_bcd_to_hex(i2c_readAck())& 0x3f; 	//std 
	


return;
}




int uart_putchar(char c, FILE *stream) // // bindet printf() ein
{
 	uart_putc(c); //UART
    return 0;
}




char rtc_bcd_to_hex(char v)// rtc_bcd_to_hex: wandelt BCD zu HEX Zahl um 
{
  char n;

  n=v; 
  n=n & 0xF0;
  n=n/16;
  v =v & 0x0F;
  n=n*10+v;
  return(n);
}

char rtc_hex_to_bcd(char v)// rtc_hex_to_bcd: wandelt HEX zu BCD Zahl um
{
  char n;

  n=v; 
  n=n/10;
  n=n*16;
  v =v % 10;
  n=n+v;
  return(n);
}


